//+------------------------------------------------------------------+
//|                                           GoStopAndProfitVVP.mq4 |
//|                                                       |
//|   ,     .           |
//|   ,                                         |
//|   ,             |
//|   (   ),        | 
//| ""    (               |
//| "" -   );             |
//| "",    (      |
//|  ""       |
//+------------------------------------------------------------------+
#property copyright " "
#property link      ""

   bool   result;
   double stop_loss,take_profit,point;
   int    cmd,total,error;
   
   extern int TrailingStop = 400;
   extern int TrailingProfit = 400;
   extern int GoStop = 1;//  "1"   ,  "0"   .
   extern int GoProfit = 1;//  "1"  ,  "0"   .

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
   
//----
   total=OrdersTotal();
   //Print("total",total);
   point=MarketInfo(Symbol(),MODE_POINT);
//----
    for(int i=0; i<total; i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         //---- print selected order
         //OrderPrint();
         cmd=OrderType();
         //---- buy or sell orders are considered
         if(cmd==OP_BUY || cmd==OP_SELL)
           {
            //---- modify first market order
            //while(true)
              
               stop_loss = OrderStopLoss();
               take_profit = OrderTakeProfit();
               
               //Print("   stop_loss ",stop_loss,"take_profit ",take_profit);
               
               if (GoStop >= 1)
               {
               if(cmd==OP_BUY) 
               {
               if((OrderStopLoss()< Ask-point*TrailingStop)||(OrderStopLoss()==0))  stop_loss=Ask-TrailingStop*point;
               }
               else
               {
               if((OrderStopLoss()> Bid+point*TrailingStop)||(OrderStopLoss()==0)) stop_loss=Bid+TrailingStop*point;
               }
               }
               
               
               if (GoProfit >= 1)
               {
               if(cmd==OP_BUY) 
               {
               if((OrderTakeProfit()>Ask+(point*TrailingProfit))||(OrderTakeProfit()==0)) take_profit=Ask+(TrailingProfit*point);
               }
               else            
               {
               if((OrderTakeProfit()<Bid-(point*TrailingProfit))||(OrderTakeProfit()==0)) take_profit=Bid-(TrailingProfit*point);               
               
               }
               }
               
               
               Print("Order #",OrderTicket()," profit: ", OrderTakeProfit());
               
               if ((stop_loss != OrderStopLoss()) || (take_profit != OrderTakeProfit()))
               {
               result=OrderModify(OrderTicket(),0,stop_loss,take_profit,0,CLR_NONE);
               //Sleep (1000);
               Print(",  -      ",stop_loss,"  ",take_profit, ": ", result);
               }            
               else
               {
               Print("  ");
               }
                              
              
           }
        }
      }
//----
   return(0);

}
//+------------------------------------------------------------------+